<?php

namespace PurchasingBundle\Repository;


use PurchasingBundle\Entity\PurchaseOrderDetail;
use Schema\SchemaEntityRepository;
use Doctrine\Common\Persistence\ManagerRegistry;
use Utils\StaticUtil\LogUtils;
use Psr\Log\LoggerInterface;

/**
 * PurchaseOrderDetailRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class PurchaseOrderDetailRepository extends SchemaEntityRepository {

    /** @var LoggerInterface $logger */
    private $logger;


    /**
     * PurchaseOrderDetailRepository constructor.
     * @param ManagerRegistry $registry
     * @param LoggerInterface $logger
     */
    public function __construct(ManagerRegistry $registry, LoggerInterface $logger) {
        parent::__construct($registry, PurchaseOrderDetail::class);
        $this->logger = $logger;
    }


    /**
     * @return mixed|null
     */
    public function findCountOrderDetails () {

        $qb = $this->getEntityManager()->createQuery(
            'SELECT count(0) AS counted 
                  FROM PurchasingBundle:PurchaseOrderDetail od'
        );

        $result = null;

        try {
            $result = $qb->setMaxResults(1)->getOneOrNullResult();
        } catch (\Exception $e) {
            $exception = LogUtils::getFormattedExceptions($e);
            $this->logger->error("Failed get count order details", $exception);
        }

        return $result;
    }


}
